<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/controllers/ajax.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.controller' );

/**
 * JMyLife Component Ajax Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerAjax extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display()
	{
		// initialize view if needed
		if( ( $view =& JRequest::getString( 'view' ) ) == FALSE )
		{
			JRequest::setVar( 'view', 'list' );
		}
		parent::display();
	}

	/**
	 * Method to display the view
	 *
	 * @access    public
	 * @param $msg string
	 * @param $amsg string
	 * since 1.0.1
	 * @param $redirect string
	 * since 1.0.2
	 * @param $params array key-value pairs to append to redirect
	 */
	function handlemessage( $msg, $amsg='', $redirect='', $params=null )
	{
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		$redirectParams = '';
		$redirectScript = '';
		// make messages the same
		if( strlen( $amsg ) == 0 ) $amsg = $msg;
		// build extra params for redirect
		if( $params != null && count( $params ) > 0 )
		{
			// fix
			array_walk( $params, 'urlencode' );
			$redirectParams = ( preg_match( '`\?`', $redirect ) ? '&' : '?' ).http_build_query( $params );
		}
		// handle message
		if( JRequest::getInt( 'ajax' ) != 1 )
		{
			// redirect... lower case for 1.6
			$appl->enqueuemessage( $msg );
			// TODO: rewrite this to handle sending data back?
			$appl->redirect( strlen( $redirect ) == 0 ? $_SERVER['HTTP_REFERER'] : $redirect );
		}
		else
		{
			if( strlen( $redirect ) != 0 )
			{
				$redirectScript = '<script type="text/javascript">
setTimeout( "window.location.href=\''.$redirect.'\';", 2000 );
</script>';
			}
			die( $amsg.$redirectScript.$redirectParams );
		}
	}

	/**
	 * Method to save a new story
	 *
	 * @access    public
	 */
	function addstory()
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$autopublish = $_JMLConfig->getBool('autopublish_stories', false);
		$insertid = 0;
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// get user
		$user =& JFactory::getUser();
		$uid  =  $user->id;
		if ($user->guest && $_JMLConfig->getBool('user_stories_only', false)) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_NOGUEST'));
		}
		$time = time();
		$catid = JRequest::getInt( 'catid', 0 );
		$fulltext = trim( JRequest::getString( 'fulltext', '' ) );
		// set alias
		$alias = JRequest::getString( 'nickname', '' );
		// handle if no alias given
		if ($_JMLConfig->getBool('force_user_name', false) && !$user->guest) {
			$alias = false === $_JMLConfig->getBool('force_user_username', false) ? $user->name : $user->username;
		} else {
			$alias = strlen( trim( $alias ) ) > 0 ? $alias : 'Anonymous';
		}
		$title = JRequest::getString( 'title', '' ); // since 1.0.5
		$email = JRequest::getVar( 'user_email' ); // since 1.0.9
		// build redirect params
		$params = JRequest::get('post');
		// check $catid
		if (0 >= $catid) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_NOCATEGORY'), $html->alert(JText::_('COM_JMYLIFE_ERROR_STORY_NOCATEGORY')));
		}
		// since 1.0.5 only check title if required
		if (0 == strlen($title) && $_JMLConfig->getBool('allow_titles', false) && $_JMLConfig->getBool('require_titles', false)) {
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_STORY_NOTITLE" ), $html->alert( JText::_( "COM_JMYLIFE_ERROR_STORY_NOTITLE" ) ) );
		}
		// check that raw fulltext has contents
		if (0 == strlen($fulltext)) {
				$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_STORY_NOTEXT"), $html->alert(JText::_("COM_JMYLIFE_ERROR_STORY_NOTEXT")));
		}
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$string = JmylifeStringHelper::getInstance();
		// check length of text & alert if there's an issue
		$limit = $_JMLConfig->getInt('editor_limit', 0);
		if (0 < $limit) {
			if (strlen($fulltext) > $limit) {
				$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_STORY_TOOLONG"), $html->alert(JText::_("COM_JMYLIFE_ERROR_STORY_TOOLONG")));
			}
			$fulltext = $string->shorten($fulltext, $limit, false);
		}
		// check token
		if( !JRequest::checkToken() )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ), $html->alert( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) ));
		}
		// setup query
		$query = JText::sprintf( 'INSERT INTO #__jmylife_stories ( '
			. '`catid`, `time`, `fulltext`, `published`, `user_id`, `user_alias`, `title`, `user_email` '
			. ') VALUES ( %s, %s, %s, %s, %s, %s, %s, %s )',
			$catid,
			$time,
			$_JMLConfig->db->quote( $fulltext ),
			$autopublish ? 1 : 0,
			$uid,
			$_JMLConfig->db->quote( $alias ),
			$_JMLConfig->db->quote( $title ),
			$_JMLConfig->db->quote( $email )
		);
		// set query
		$_JMLConfig->db->setQuery( $query );
		// run it!
		if( $_JMLConfig->db->query() )
		{
			$insertid = $_JMLConfig->db->insertid();
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			// since 1.0.5 message is conditional based on moderation status
			$msg = JText::_( false === $autopublish ? 'COM_JMYLIFE_STORY_THANKSFORTHEMODERATEDSTORY' : 'COM_JMYLIFE_STORY_THANKSFORTHESTORY' );
			if ($_JMLConfig->getBool('email_enabled', false) && $_JMLConfig->getBool('notify_stories', false)) {
				$mailer->send(
					$_JMLConfig->get( 'email_to' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_SUBMISSIONBODY' ), $insertid ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_SUBMISSIONSUBJECT' ), $insertid ),
					true
				);
			}
			// since 1.0.9 notify users if their story has been approved
			if ($_JMLConfig->getBool('notify_author_stories', false) && strlen($email)) {
				if ($autopublish) {
					$mailer->authorPending( $insertid, $email );
				} else {
					$mailer->authorPublished( $insertid, $email );
				}
			}
			// since 1.0.9 users are subscribed to their stories
			// since this is a new story there's no need to check against the db (afaik)
			if ($_JMLConfig->getBool('notify_author_comments', false)) {
				$query = "INSERT INTO `#__jmylife_stories_subscriptions` ( `uid`, `sid` ) VALUES ( {$uid}, {$insertid} )";
				$_JMLConfig->db->setQuery( $query );
				$_JMLConfig->db->query();
			}
		}
		else
		{
			$msg = JText::_( 'COM_JMYLIFE_ERROR_STORY_CANNOTSAVE' );
		}
		// make sure form redirects to the right place
		$formsubmit = '<script type="text/javascript">
//<!--
%s
// -->
</script>';
		// script is dependent on submitted form
		$form = JRequest::getWord('form');
		$formsubmitscript = 'alert("'.$msg.'");window.jml.jQuery(\'#'.$form.'\').empty();';
		// handle either module or jomsocial form
			$timeoutCode = "window.location.href='".JURI::base()."';";
			if( $_JMLConfig->getInt( 'submissionredirect', 0 ) > 0 )
			{
				// get menu item href for redirect
				$_JMLConfig->db->setQuery( 'SELECT `link` FROM `#__menu` WHERE `id` = '.$_JMLConfig->getInt( 'submissionredirect' ), 0, 1 );
				// fixed in 1.0.11 to append Itemid & run through JRoute
				if( !( $link = $_JMLConfig->db->loadResult() ) ) $link = JURI::base();
				else $link .= ( preg_match( '`\?`', $link ) ? '&' : '?' ) . 'Itemid='.$_JMLConfig->getInt( 'submissionredirect' );
				$link = JRoute::_( $link, false );
				$timeoutCode = "window.location.href='$link';";
			}
			$formsubmitscript .= 'setTimeout( "'.$timeoutCode.'", 1000 );';
		$formsubmit = JText::sprintf( $formsubmit, $formsubmitscript );
		// end
		$this->handlemessage( $msg, $formsubmit );
	}

	/**
	 * Method to save a comment
	 *
	 * @access    public
	 */
	function addcomment()
	{
		// check token
		if (!JRequest::checkToken()) {
			$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_INVALID_TOKEN"));
		}
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if (!$_JMLConfig->getInt('allow_comments',1)) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_COMMENT_NOTALLOWED'));
		}
		// get user
		$user =& JFactory::getUser();
		$uid  =  $user->id;
		// is ajax?
		$ajax = JRequest::getInt('ajax');
		// only users can comment, sorry!
		if ($user->guest) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_COMMENT_NOGUEST'));
		}
		// insert params
		$sid = JRequest::getInt('sid');
		if (0 >= $sid) {
			$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_STORY_NOID"));
		}
		// no longer quoted in declaration - 1.0.9 email notification bugfix
		$fulltext = JRequest::getString('comment');
		// check that $fulltext has contents
		if (0 == strlen($fulltext)) {
			$this->handlemessage(JText::_("COM_JMYLIFE_ERROR_COMMENT_BLANK"));
		}
		// leave in case we expand comments to anon
		// why does this matter? no need to tempt the voodoo gods now...
		$alias = strlen($user->name) ? $user->name : 'Anonymous';
		// setup query
		$query = 'INSERT INTO #__jmylife_comments ( '
		       . '`sid`, `message`, `author`, `author_id`, `time`, `published` '
		       . ') VALUES ( '
		       . $sid.', '.$_JMLConfig->db->quote( $fulltext ).', '.$_JMLConfig->db->quote( $alias ).', '.$uid.', '.time().', '.$_JMLConfig->getInt('autopublish_comments',0).' '
		       . ')'
		;
		// set query
		$_JMLConfig->db->setQuery( $query );
		// run it!
		if ($_JMLConfig->db->query()) {
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$cid = $_JMLConfig->db->insertid();
			$autopublish = (bool)$_JMLConfig->getInt('autopublish_comments',0);
			$msg = JText::_( $autopublish ? 'COM_JMYLIFE_COMMENT_THANKSFORTHECOMMENT' : 'COM_JMYLIFE_COMMENT_THANKSFORTHEMODERATEDCOMMENT' );
			// send email to admin
			if ($_JMLConfig->getInt('email_enabled', 0) && $_JMLConfig->getInt('notify_comments', 0)) {
				JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
				$string = JmylifeStringHelper::getInstance();
				// save myself the ctrl+c/ctrl+v action *wink to Bill*
				$mailer->send(
					$_JMLConfig->get( 'email_to' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_COMMENTBODY' ), $cid, 'comment' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_COMMENTSUBJECT' ), $cid, 'comment' ),
					true
				);
			}
			if ($autopublish) {
				// send email to subscribers
				$mailer->commentSubscribers($cid);
				// subscribe commenter to this story, if needed ;)
				$query = "SELECT `id` FROM `#__jmylife_stories_subscriptions` WHERE `uid` = {$uid} AND `sid` = {$sid}";
				$_JMLConfig->db->setQuery($query);
				if (1 > intval($_JMLConfig->db->loadResult())) {
					$query = "INSERT INTO `#__jmylife_stories_subscriptions` ( `uid`, `sid` ) VALUES ( {$uid}, {$sid} )";
					$_JMLConfig->db->setQuery( $query );
					$_JMLConfig->db->query();
				}
			}
		} else {
			$msg = JText::_( 'COM_JMYLIFE_ERROR_COMMENT_CANNOTSAVE' );
		}
		$formsubmit = '';
		// if we're autoposting comments, reload the page...
		if ($autopublish) {
			// handle redirection manually here (lame)...
			// TODO: load up an individual comment template
			$formsubmit = '<script type="text/javascript">
//<!--
	window.jml.jQuery(\'#'.JRequest::getString('form').'\').empty();
	setTimeout( "window.location.reload();", 1000 );
// -->
</script>';
		}
		// end
		$this->handlemessage( $msg, $html->alert( $msg ).$formsubmit );
		// end
		$this->handlemessage( $msg );
	}

	/**
	 * Methods to count votes
	 *
	 * @access    public
	 */
	function countvotes( $id, $dir )
	{
		// $dir will only be '1' or '2' so error on any others (not needed?)
		if( $dir != '1' && $dir != '2' )
		{
			JError::raiseError( 500, JText::_( "COM_JMYLIFE_ERROR_VOTING_BADINPUT" ) );
		}
		// set up database
		$database =& JFactory::getDBO();
		$query = 'SELECT `votes'.$dir.'` FROM `#__jmylife_stories` WHERE `id` = '.$id;
		$database->setQuery( $query );
		if( !( $result = $database->loadResult() ) )
		{
			// since 1.0.9 just return a 0
			return 0;
		}
		return intval( $result );
	}

	/**
	 * Methods to save votes
	 *
	 * @access    public
	 */
	function votegood()
	{
		$this->vote( '1' );
	}
	function votebad()
	{
		$this->vote( '2' );
	}
	function vote( $dir )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if( $_JMLConfig->getInt('allow_votes') == 0 )
		{
			$this->handlemessage( JText::_( 'COM_JMYLIFE_ERROR_VOTING_DISABLED' ) );
			exit();
		}
		// $dir will only be '1' or '2' so error on any others (not needed?)
		if( $dir != '1' && $dir != '2' )
		{
			$this->handlemessage( JText::_( 'COM_JMYLIFE_ERROR_VOTING_BADINPUT' ) );
			exit();
		}
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// get user
		$user =& JFactory::getUser();
		// guest vote check
		if ($user->guest && 0 == $_JMLConfig->getInt('allow_votes_guests', 1)) {
			$this->handlemessage( JText::_( 'COM_JMYLIFE_ERROR_VOTING_NOGUEST' ) );
			exit();
		}
		// vote params
		$sid = intval( JRequest::getInt( 'sid' ) );
		// check story id
		if( $sid <= 0 )
		{
			JError::raiseError( 404, JText::_( "COM_JMYLIFE_ERROR_STORY_NOID" ) );
		}
		// check token
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
			exit();
		}

		// update vote table so each person can only vote once
		// TODO: possibly match something else to allow for widespread use without abuse
		//       cookies are a possibility, but not something I'm a fan of...

		// first we gotta check
		// block_votes_by_ip added in 1.0.13 due to user request
		// if true, instead check cookies (ew)

		$allowVote = true;
		$ip = $_JMLConfig->db->quote( long2ip( ip2long( $_SERVER['REMOTE_ADDR'] ) ) );
		if (1 == $_JMLConfig->getInt('block_votes_by_ip', 1)) {
			// first we gotta check
			$query = 'SELECT `ip` FROM `#__jmylife_votes` WHERE `ip` = '.$ip.' AND `sid` = '.$sid;//.' AND `uid` = '.$user->id;
			// set query
			$_JMLConfig->db->setQuery($query);
			$votedIp = $_JMLConfig->db->loadObjectList();
			if (!empty($votedIp)) {
				$allowVote = false;
			}
		} else {
			// check cookie
			if (isset($_COOKIE["JmlVote{$sid}"])) {
				$allowVote = false;
			}
			setcookie("JmlVote{$sid}", 1);
		}
		// check number of rows found
		if( $allowVote )
		{
			// record vote
			$query = 'INSERT INTO `#__jmylife_votes` ( `ip`, `sid`, `uid` ) VALUES ( '.$ip.', '.$sid.', '.$user->id.' )';
			$_JMLConfig->db->Execute( $query );
			// update vote counter
			$query = 'UPDATE `#__jmylife_stories` SET votes'.$dir.' = votes'.$dir.'+1 WHERE id='.$sid;
			$_JMLConfig->db->Execute( $query );
		}
		else
		{
			$count = $this->countvotes( $sid, $dir );
			$graphicResponse = array( 'success' => false, 'msg' => JText::_( 'COM_JMYLIFE_ERROR_VOTING_ALREADYVOTED' ), 'count' => $count );
			$this->handlemessage( JText::_( 'COM_JMYLIFE_ERROR_VOTING_ALREADYVOTED' ), $_JMLConfig->getInt( 'graphical_voting', 0 ) == 1 ? json_encode( $graphicResponse ) : JText::_( 'COM_JMYLIFE_ERROR_VOTING_ALREADYVOTED' ).' ('.$count.')' );
		}
		// end
		$count = $this->countvotes( $sid, $dir );
		$msg = JText::_( 'COM_JMYLIFE_ERROR_YOUSHOULDNEVERSEETHIS' );
		// text changed to use database config since 1.0.4, still use lang file fallback
		if( $dir == '1' )
		{
			$responseText = $_JMLConfig->get('votegoodresponse_text');
			$msg = strlen( $responseText ) > 0 ? $responseText : JText::_( 'COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEGOODRESPONSE' );
		}
		else if( $dir == '2' )
		{
			$responseText = $_JMLConfig->get('votebadresponse_text');
			$msg = strlen( $responseText ) > 0 ? $responseText : JText::_( 'COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEBADRESPONSE' );
		}
		$graphicResponse = array( 'success' => true, 'msg' => $msg, 'count' => $count );
		$this->handlemessage( $msg, $_JMLConfig->getInt( 'graphical_voting', 0 ) == 1 ? json_encode( $graphicResponse ) : $msg.' ('.$count.')' );
	}

	/**
	 * Methods to report comments
	 *
	 * @access    public
	 */
	function report()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$user =& JFactory::getUser();
		$id = JRequest::getInt( 'cid' );
		// check token
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
		}
		// first we gotta check
		$ip = $_JMLConfig->db->quote( long2ip( ip2long( $_SERVER['REMOTE_ADDR'] ) ) );
		$query = 'SELECT `ip` FROM `#__jmylife_comments_warnings` WHERE `ip` = '.$ip.' AND `cid` = '.$id.' AND `uid` = '.$user->id;
		// set query
		$_JMLConfig->db->setQuery( $query );
		// run it
		$_JMLConfig->db->query();
		// check number of rows found
		if( $_JMLConfig->db->getNumRows() == 0 )
		{
			$query = 'INSERT INTO `#__jmylife_comments_warnings` ( `ip`, `cid`, `uid` ) VALUES ( '.$ip.', '.$id.', '.$user->id.' )';
			// set query
			$_JMLConfig->db->setQuery( $query );
			// run it
			$_JMLConfig->db->query();
			// notify, if set
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$string = JmylifeStringHelper::getInstance();
			if( $_JMLConfig->getInt('notify_any_warning') != 0 && $_JMLConfig->getInt( 'email_enabled' ) == 1 )
			{
				$mailer->send(
					$_JMLConfig->get( 'email_to' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_WARNANYBODY' ), $id, 'comment' ),
					$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_WARNANYSUBJECT' ), $id, 'comment' ),
					true
				);
			}
			// check count and alert if needed...
			if( $_JMLConfig->getInt('notify_warning') != 0 )
			{
				$query = 'SELECT COUNT(ip) AS c FROM `#__jmylife_comments_warnings` WHERE `cid` = '.$id;
				$_JMLConfig->db->setQuery( $query );
				if( $count = $_JMLConfig->db->loadResult() )
				{
					if( $_JMLConfig->getInt( 'email_enabled' ) == 1 && (int)$count == $_JMLConfig->getInt('warning_level') )
					{
						// common lib ;)
						$mailer->send(
							$_JMLConfig->get( 'email_to' ),
							$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_WARNLEVELBODY' ), $id ),
							$string->stubs( JText::_( 'COM_JMYLIFE_MAIL_ADMIN_WARNLEVELSUBJECT' ), $id ),
							true
						);
					}
				}
			}
			// update vote counter
			$this->handlemessage( JText::_( 'COM_JMYLIFE_COMMENT_THANKSFORTHEWARNING' ) );
		}
		else
		{
			$this->handlemessage( JText::_( 'COM_JMYLIFE_COMMENT_ALREADYREPORTED' ) );
		}
	}


	/**
	 * Methods to report comments
	 *
	 * @access    public
	 * @since     1.0.10
	 */
	function reportstory() {
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$story = JmylifeStoryHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$sid = JRequest::getInt('sid');
		// die if story id is 0
		if (0 >= $sid) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_NOID'));
		}
		// get story contents
		$_JMLConfig->db->setQuery($story->buildQuery(array('view' => 'item', 'id' => $sid)));
		// die if story cannot be found
		if (!($item = $_JMLConfig->db->loadObject())) {
			$this->handlemessage(JText::_('COM_JMYLIFE_ERROR_STORY_NOID'));
		}
		$item = $story->prepare($item, 'item');
		if (0 == (int)$item->reported) {
			$this->handlemessage(JText::_('COM_JMYLIFE_STORY_ALREADYREPORTED'));
		}
		if ($_JMLConfig->getInt('email_enabled', 0) && strlen($_JMLConfig->get('email_to'))) {
			JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
			JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
			$mailer = JmylifeEmailHelper::getInstance();
			$string = JmylifeStringHelper::getInstance();
			// send mail
			$mailer->send(
				$_JMLConfig->get('email_to'),
				$string->stubs(JText::_('COM_JMYLIFE_MAIL_ADMIN_REPORTSTORYBODY'), $sid),
				$string->stubs(JText::_('COM_JMYLIFE_MAIL_ADMIN_REPORTSTORYSUBJECT'), $sid),
				true
			);
		}
		$_JMLConfig->db->setQuery('UPDATE `#__jmylife_stories` SET `reported` = 1 WHERE `id`='.$item->id);
		$_JMLConfig->db->query();
		$this->handlemessage(JText::_('COM_JMYLIFE_STORY_REPORTED'));
	}

	/**
	 * Method to return a comment
	 *
	 * @access    public
	 * @since     1.0.4
	 */
	function getcomment()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$id = JRequest::getInt( 'id' );
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
		}
		// var init
		$join = '';
		$group = '';
		$fields = array( 'c.*' );

		// build query
		$query = 'SELECT '
		       . implode( ', ', $fields ).' '
		       . 'FROM `#__jmylife_comments` AS c '
		       . $join
		       . 'WHERE c.`id`='.$id.' AND c.`published`=1 '
		       . $group
		       ;
		$_JMLConfig->db->setQuery( $query );
		$comment = $_JMLConfig->db->loadObject();
		if( count( $comment ) == 0 )
		{
			$comment = new stdClass();
			$comment->message = JText::_('COM_JMYLIFE_ERROR_COMMENT_NOTFOUND');
			$comment->id = 0;
			$comment->time = 0;
			$comment->author = '';
			$comment->author_id = 0;
		}
		die( json_encode( $comment ) );
	}

	/**
	 * function getlatestcomments()
	 * @since   1.0.10
	 */
	function getlatestcomments()
	{
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$comment = JmylifeCommentHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$output = '';
		$query = $comment->buildQuery( JRequest::getInt( 'id' ) ).' LIMIT '.$_JMLConfig->getInt( 'comment_balloon_count', 5 );
		$_JMLConfig->db->setQuery( $query );
		if( $rows = $_JMLConfig->db->loadObjectList() )
		{
			$rows = $comment->prepareList( $rows );
			if( count( $rows ) )
			{
				JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
				$string = JmylifeStringHelper::getInstance();
				foreach( $rows as $row )
				{
					$output .= '<p class="jmylifeBalloonItem">'
					        .  $string->shorten( $row->message, $_JMLConfig->getInt( 'comment_balloon_length', 200 ), false )
					        .  '</p>'
					        ;
				}
			}
		}
		$output .= '<div class="jmylifeBalloonFooter">'.JText::_('COM_JMYLIFE_COMMENT_CLICKTOCOMMENT').'</div>';
		die( $output );
	}

	/**
	 * function unsubscribe
	 * @since   1.0.9
	 */
	function unsubscribe()
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$user =& JFactory::getUser();
		$uid  =  $user->id;
		$sid  = JRequest::getInt( 'sid' );
		// hmm, guests shouldn't be able to unsubscribe
		if( $user->guest )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_STORY_GUESTNOTSUBSCRIBED" ) );
		}
		// check token
		if( !JRequest::checkToken( 'get' ) )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_INVALID_TOKEN" ) );
		}
		// just blindly delete based on user id ;)
		$query = "DELETE FROM `#__jmylife_stories_subscriptions` WHERE uid = {$uid} AND sid = {$sid}";
		$_JMLConfig->db->setQuery( $query );
		if( $_JMLConfig->db->query() )
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_STORY_UNSUBSCRIBESUCCESS" ) );
		}
		else
		{
			$this->handlemessage( JText::_( "COM_JMYLIFE_ERROR_STORY_UNSUBSCRIBE" ) );
		}
	}

	/**
	 * jQuery
	 */
	function jQuery() {
		header("Content-type: text/javascript");
		// defensive coding - jml libs should access window.jml.jQuery
		// this is so jml has its own jQuery, apart from everyone else's
		// hopefully, this prevents any kind of conflict anywhere
		echo <<<EOF
var oldQuery=false;
if ('undefined'!=typeof jQuery){
	oldQuery = jQuery;
}
EOF;
		echo @file_get_contents(JPATH_JMYLIFELIBS.DS.'jquery'.DS.'jquery-1.4.2.min.js')."\n";
		echo @file_get_contents(JPATH_JMYLIFELIBS.DS.'jquery'.DS.'jquery.noconflict.js')."\n";
		echo <<<EOF
if (oldQuery){
	jQuery = oldQuery;
}
EOF;
		echo "window.jml.root = '".JURI::root(false)."';\n";
		die();
	}
}