<?php
/**
 * @package		horizonSlim
 * @license		GNU/GPLv3 see GPL.txt
 */
defined('_JEXEC') or die('Direct Access to this location is not allowed.');
 
class ModHorizonSlim 
{
	private	$horizon_article_id;
	private	$horizon_class;

	private	$horizon_width;
	private	$horizon_height;

	private	$horizon_list_width;
	private	$horizon_fadeSpeed;
	private	$horizon_maxOpacity;

	private	$horizon_slide_delay;
	private	$horizon_slideSpeed;
	private	$horizon_startSl;
	private	$horizon_direction;

	private	$horizon_hoverEffect;
	private	$horizon_clickEffect;
	private	$horizon_even;
	private	$horizon_forceCollapse;

	private	$horizon_desc_width;
	private	$horizon_desc_height;
	private	$horizon_desc_dir;
	private	$horizon_desc_Speed;
	private	$horizon_maxOpacityDes;
	private	$horizon_alwaysShowDes;

	private	$horizon_autoplay;
	private	$horizon_autoplay_Speed;
	private	$horizon_ClickStopsAutoplay;

	private $horizon_debug;
	private $horizon_debugJs;


	private	$horizon_articles;
	private	$horizon_html;

	private	$parseImages;
	private	$parseDivs;
	
	private $horizon = array();
	
	private $baseClassName = 'negeticsHorizon';
	
	private $mod;
    
	function __construct($params,$module)
	{                                           
		$this->horizon_article_id									= $params->get('article_id');
		$this->horizon_width 											= $params->get('listWidth',0);
		$this->horizon_height 										= $params->get('listHeight',200);
		$this->horizon_list_width 								= $params->get('list_width',600);
		$this->horizon_desc_width 								= $params->get('desc_width');
		$this->horizon_desc_height 								= $params->get('desc_Height');
		$this->horizon_desc_dir		 								= $params->get('descDirection');
		$this->horizon_class											= $params->get('class');
		$this->horizon_slide_delay 								= $params->get('slide_delay');
		$this->horizon_slideSpeed 								= $params->get('slideSpeed');
		$this->horizon_startSl 										= $params->get('startSl');
		$this->horizon_hoverEffect 								= $params->get('hoverEffect');
		$this->horizon_clickEffect 								= $params->get('clickEffect');
		$this->horizon_even 											= $params->get('even');
		$this->horizon_direction 									= $params->get('direction');
		$this->horizon_fadeSpeed 									= $params->get('fadeSpeed');
		$this->horizon_maxOpacity 								= $params->get('maxOpacity');
		$this->horizon_forceCollapse 							= $params->get('forceCollapse');
		$this->horizon_autoplay 									= $params->get('autoplay');
		$this->horizon_desc_Speed 								= $params->get('desc_Speed');
		$this->horizon_autoplay_Speed 						= $params->get('autoplaySpeed');
		$this->horizon_ClickStopsAutoplay 				= $params->get('ClickStopsAutoplay');
		$this->horizon_maxOpacityDes							= $params->get('maxOpacityDescription');
		$this->horizon_alwaysShowDes							= $params->get('alwaysShowDes',0);
		$this->horizon_desFadeOut									= $params->get('desFadeOut',0);

		$this->horizon_parseImages								= true;

		$this->horizon_debugJs 										= $params->get('debugJs');
		$this->horizon_debug											= $params->get('debug');

		$this->mod																= $module;

//	Override true false parameters
		if($this->horizon_hoverEffect 					== 1)	{$this->horizon_hoverEffect = "true";}					else{$this->horizon_hoverEffect = "false";}
		if($this->horizon_clickEffect 					== 1)	{$this->horizon_clickEffect = "true";}					else{$this->horizon_clickEffect = "false";}
		if($this->horizon_even 									== 1)	{$this->horizon_even = "true";}									else{$this->horizon_even = "false";}
		if($this->horizon_forceCollapse 				== 1)	{$this->horizon_forceCollapse = "true";}				else{$this->horizon_forceCollapse = "false";}
		if($this->horizon_autoplay 							== 1)	{$this->horizon_autoplay = "true";}							else{$this->horizon_autoplay = "false";}
		if($this->horizon_ClickStopsAutoplay 		== 1)	{$this->horizon_ClickStopsAutoplay = "true";}		else{$this->horizon_ClickStopsAutoplay = "false";}
		if($this->horizon_alwaysShowDes 				== 1)	{$this->horizon_alwaysShowDes = "true";}				else{$this->horizon_alwaysShowDes = "false";}
		if($this->horizon_desFadeOut 						== 1)	{$this->horizon_desFadeOut = "true";}						else{$this->horizon_desFadeOut = "false";}

		$this->horizon['horizon_width']					=	$this->horizon_width;
		$this->horizon['horizon_height']				=	$this->horizon_height;
		$this->horizon['horizon_list_width']		=	$this->horizon_list_width;
		$this->horizon['horizon_desc_width']		=	$this->horizon_desc_width;
		$this->horizon['horizon_desc_height']		=	$this->horizon_desc_height;
		$this->horizon['horizon_class']					=	$this->horizon_class;

		$this->buildJavascript();
		$this->getArticle();
		$this->getListParas();
		$this->buildHorizon();
		$this->horizonDebug();
		$this->horizonDebugJs();
	}

	public function buildJavascript()
	{
		$this->horizon['js'] .=  
			'<script type="text/javascript">var slideMenu' . 
				$this->mod->id . 
			' = new horizon(); slideMenu' . 
				$this->mod->id . 
			'.build("sm' . 
				$this->mod->id .	'", ' . 
						 $this->horizon_list_width . 
			', ' . $this->horizon_slide_delay . 
			', ' . $this->horizon_slideSpeed . 
			', ' . $this->horizon_startSl . 
			', ' . $this->horizon_hoverEffect . 
			', ' . $this->horizon_clickEffect . 
			', ' . $this->horizon_even . 
			', ' . $this->horizon_direction . 
			', ' . $this->horizon_fadeSpeed . 
			', ' . $this->horizon_maxOpacity . 
			', ' . $this->horizon_forceCollapse . 
			', ' . $this->horizon_desc_dir . 
			', ' . $this->horizon_autoplay . 
			', ' . $this->horizon_ClickStopsAutoplay . 
			', ' . $this->horizon_desc_Speed . 
			', ' . $this->horizon_autoplay_Speed . 
			', ' . $this->horizon_maxOpacityDes . 
			', ' . $this->horizon_alwaysShowDes . 
			', ' . $this->horizon_desFadeOut . 
			');</script>';
	}

	public function getHorizon()
	{
		return $this->horizon;
	}

	public function getArticle()
	{
		$db = &JFactory::getDBO();
		
		$query  = "select ";
		$query .= "con.id, con.alias, con.introtext, cat.alias as catalias, con.catid, ";
		$query .= "con.title ";
		$query .= "from #__content as con, #__categories as cat ";
		$query .= "where con.id = ".$this->horizon_article_id." ";
		$query .= "and con.catid = cat.id ";
		$query .= "and con.state = 1 ";
		
		$db->setQuery($query);
		$this->horizon_articles = ($articles = $db->loadObjectList())?$articles:array();
		return $this->horizon_articles;
	}

	public function horizonDebug()
	{
//	debugging Div for javascript output
		if($this->horizon_debug == 1)
		{
			echo '<pre style="background:#AFAFAF;">';
			print_r($this->horizon);
			echo "</pre>";
		}
	}

	public function horizonDebugJs()
	{
//	debugging Div for javascript output
		$debug = "";
		if($this->horizon_debugJs == 1)
		{
			$debug = '<div id="debug" style="padding:10px; font-weight:bold; color:#efefef;">DEBUG</div>';
		}
		$this->horizon['debugJs']	= $debug;
	}

	public function getListParas()			// 	get the parameters for our main List Element
	{
		$this->horizon['list']						= 	array();
		$this->horizon['list']['class']		= 	$this->baseClassName;
		$this->horizon['list']['id']			= 	'sm'.$this->mod->id;
		$this->horizon['list']['style']		=		"";
		
		if($this->horizon_class != "")
		{
			$this->horizon['list']['class']	.= 	" ".$this->horizon_class;
		}

		$this->horizon['list']['style'] 	.= 	"";
		
		if($this->horizon_height!=0)
		{					
			$this->horizon['list']['style'] .= 	'height:'.$this->horizon_height.'px;';
		}

		if($this->horizon_width!=0)
		{
			$this->horizon['list']['style'] .= 	' width:'.$this->horizon_width.'px;';
		}
		return $this->horizon['list'];
	}


	public function buildHorizon()
	{
		$horizonSrc = $this->horizon_articles[0]->introtext;								//	get the html String from the Article
		$doc 				= new DOMDocument();																		//	craete A DOMDocument to make HTML manipulation easy
		if ($doc->loadHTML("<html><body>".$horizonSrc."</body></html>"))		//	Try for valid dom structure and start parsing
		{
			$body 				= $doc->getElementsByTagName('body');										//	get the body
			$itemsB 			= $body->item(0)->getElementsByTagName('div');					//	try for parsable Divs
			$parseDivs 		= false;
			if($itemsB->length > 0)
			{
				$parseDivs	=	true;
			}
			
			if($parseDivs)																										//	parse the Divs
			{
				$this->parseDivs($itemsB);
			}
			elseif($this->horizon_parseImages)																//	if no Divs were found parse Images
			{
				$this->parseImages($doc);
			}
		}
	}

	public function parseImages($doc)
	{
		$this->horizon['elements']	= array();
		$count = 0;
		
		$items = $doc->getElementsByTagName('img');
		$images = array();
		
		foreach($items as $item)
		{
			$src 		= $item->getAttribute('src');
			$alt 		= $item->getAttribute('alt');
			$title 	= $item->getAttribute('title');
			
			$this->horizon['elements'][$count] 					= array();
			
			$this->horizon['elements'][$count]['imSrc']	= $item->getAttribute('src');
			$this->horizon['elements'][$count]['des'] 	= $item->getAttribute('alt');
			$this->horizon['elements'][$count]['title'] = $item->getAttribute('title');
			$count++;
		}
//	initialize the script
	} 

	public function parseDivs($itemsB)
	{
		$this->horizon['elements']	= array();
		$count = 0;

		foreach($itemsB as $itemB)
		{
			if( $itemB->parentNode->nodeName == "body" )	// check if div has to be processed
			{
//			test for embedded Objects - will be used in later version for now you have to do them right by yourself ;)		    	
//	  	$embeds = $itemB->getElementsByTagName('embed');	
//	  	if($embeds->length > 0){$embedded=true;}
//	  	else{$embedded=false;}

				$this->horizon['elements'][$count] 					= array();

//			check for a main Link to put over the Slide
				$link 	= false;
				$items 	= $itemB->getElementsByTagName('a');

				if( $items->item(0) && $items->item(0)->parentNode->isSameNode($itemB) )
				{
					$this->horizon['elements'][$count]['link']			= $items->item(0)->getAttribute('href');
					$this->horizon['elements'][$count]['linkText']	= $items->item(0)->nodeValue;
				}
//				check for main Image		    	
				$items 				= $itemB->getElementsByTagName('img');
				$src 					= $items->item(0)->getAttribute('src');
//				check for fade Image
				if($items->item(1) && $items->item(1)->parentNode->isSameNode($itemB))
				{
					$this->horizon['elements'][$count]['imSrc2']	= $items->item(1)->getAttribute('src');
				}
//				get the Description Layer paragraphs

				$parseDivs 		= $this->checkForDirectChild($itemB,'div');			//	try for parsable Divs
				
				if($parseDivs)
				{
					$type = 'div';
					$description	= $this->parseBlockElement($itemB,$type);
				}
				else
				{
					$parseDivs 		= $this->checkForDirectChild($itemB,'p');			//	try for parsable paragraphs
					if($parseDivs)
					{
						$type = 'p';
						$description	= $this->parseBlockElement($itemB,$type);
					}
					else
					{
						$description	= "";
					}
				}

				$this->horizon['elements'][$count]['imSrc']	= $src;
				$this->horizon['elements'][$count]['des'] 	= $description;
				$this->horizon['elements'][$count]['title'] = $itemB->getAttribute('title');
				$count++;
			}
		}
	}

	public function parseBlockElement($src,$type)
	{
		$items 				= $src->getElementsByTagName($type);
    	
//		new Dom Object for cloning paragraphs
		$docP 				= new DOMDocument();
		$docP->loadHTML("<html></html>");
//		clone the paragraphs
		foreach($items as $item)
		{
			if($item->parentNode->isSameNode($src))
			{
				$node 			= $docP->importNode($item, true);
				$docP->documentElement->appendChild($node);
			}
		}
		$tempHTML			= $docP->saveHTML();
//		remove the unneccesary html parts
		preg_match("/<html>(.+?)<\/html>/s",$tempHTML , $paras );
		$description	= $paras[1];
		return $description;
	}

	public function checkForDirectChild($father,$childType)
	{
		$children 		= $father->getElementsByTagName($childType);					//	try for Children
		$directChild 	= false;
		if($children->length > 0)
		{
			foreach($children as $child)
			{
				if($child->parentNode->isSameNode($father))
				{
					$directChild	=	$childType;
				}
			}
		}
		return $directChild;
	}

}

